# Advent of Code 2023 solutions

A set of 25 puzzle inputs and 50 puzzle solutions, two for each day. Most can
be solved in minutes.  The puzzles can be found
[here](https://adventofcode.com/2023/), although only the first one for each
day is visible until you solve it.

Most solutions output at most two lines, the answers to part 1 and 2; but some
provide more information in the form of e.g. graphics.

Run a solution by passing the puzzle input to the program:

```
./two.awk < input2
```
or
```
./five.py -v < test5
```
or
```
kotlinc -include-runtime -d seven.jar seven.kt && java -jar seven.jar < input7
```
or
```
./sechszehn.py -vv <input16
```
or
```
./xmaseve.py -v 7 27 <test24
```
