#!/usr/bin/env python3

from useful import *

def draw(pic):
    for y in range(pic.shape[0]):
        for x in range(pic.shape[1]):
            print('#' if pic[y,x] == 1 else 'O' if pic[y,x] == 2 else '.', end='')
        print()

def load(pic):
    return sum(n[0] for n in np.argwhere(np.pad(pic[::-1], ((1,0),(0,0))) == 2))

ms = np.array([[{'.':0,'#':1,'O':2}[c] for c in l] for l in lines(open(0))]).astype('int')
h, w = ms.shape

lastnorths=[]
cycling=True
first=True

for k in count():
    if not cycling:
        break
    for i in range(4):
        for j in range(h-1):
            for u in range(h-1):
                for v in range(w):
                    if not ms[u,v] and ms[u+1,v] == 2:
                        ms[u,v] = 2
                        ms[u+1,v] = 0
        if first:
            print(load(ms))
            first = False
        ms = np.rot90(ms, 3)
    for i, ln in enumerate(lastnorths):
        if np.all(ms == ln):
            hi, lo, cycle = k, i, k - i
            cycling = False
    lastnorths.append(ms.copy())
guess = 999999999%cycle
while guess < lo:
    guess += cycle
print(load(lastnorths[guess]))
